VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmMain 
   Caption         =   "ICS Serial Device Program"
   ClientHeight    =   7710
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8580
   Icon            =   "Serial_Terminal.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   7710
   ScaleWidth      =   8580
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtRev 
      BackColor       =   &H80000004&
      BorderStyle     =   0  'None
      Height          =   255
      Left            =   5160
      TabIndex        =   20
      Text            =   "Revised 02-02-05"
      Top             =   7440
      Width           =   1815
   End
   Begin VB.TextBox txtERROR 
      Height          =   285
      Left            =   480
      TabIndex        =   19
      Text            =   "Text1"
      Top             =   360
      Visible         =   0   'False
      Width           =   6375
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   6000
      Top             =   5040
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      RTSEnable       =   -1  'True
   End
   Begin VB.Frame frmCOMPorts 
      Caption         =   "COM Ports"
      Height          =   855
      Left            =   6720
      TabIndex        =   17
      Top             =   720
      Width           =   1455
      Begin VB.CommandButton cmdInitCP 
         Caption         =   "Select Port"
         Height          =   375
         Left            =   120
         TabIndex        =   18
         ToolTipText     =   "Selects COM Port and Baud Rate"
         Top             =   360
         Width           =   1215
      End
   End
   Begin VB.Timer Timer1 
      Interval        =   500
      Left            =   6120
      Top             =   4320
   End
   Begin VB.TextBox txtLpCtr 
      Height          =   375
      Left            =   4680
      TabIndex        =   15
      Top             =   6600
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Frame frmCmdLp 
      Caption         =   "Response Test Loop"
      Height          =   1095
      Left            =   480
      TabIndex        =   12
      Top             =   6480
      Width           =   3375
      Begin VB.CheckBox ckERRStp 
         Caption         =   "Stop on Error"
         Height          =   195
         Left            =   1800
         TabIndex        =   23
         Top             =   240
         Width           =   1335
      End
      Begin VB.CommandButton cmdStopLP 
         Caption         =   "StopResponses"
         Height          =   495
         Left            =   1680
         TabIndex        =   14
         ToolTipText     =   "Stops command send loop"
         Top             =   480
         Width           =   1455
      End
      Begin VB.CommandButton cmdStartLP 
         Caption         =   "Start Response"
         Height          =   495
         Left            =   120
         TabIndex        =   13
         ToolTipText     =   "Starts comand send loop"
         Top             =   480
         Width           =   1335
      End
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   6960
      TabIndex        =   11
      ToolTipText     =   "Exits program"
      Top             =   6960
      Width           =   1095
   End
   Begin VB.Frame frm4895 
      Caption         =   "Cmds"
      Height          =   1335
      Left            =   6720
      TabIndex        =   8
      Top             =   1920
      Width           =   1455
      Begin VB.CommandButton cmdInit 
         Caption         =   "Initialize"
         Height          =   375
         Left            =   120
         TabIndex        =   10
         ToolTipText     =   "Initializes COM Port and 4895"
         Top             =   360
         Width           =   1215
      End
      Begin VB.CommandButton cmdReset 
         Caption         =   "Reset"
         Height          =   375
         Left            =   120
         TabIndex        =   9
         ToolTipText     =   "Forces 4895 reset"
         Top             =   840
         Width           =   1215
      End
   End
   Begin VB.Frame frmResp 
      Caption         =   "Serial Input"
      Height          =   3135
      Left            =   480
      TabIndex        =   2
      Top             =   3120
      Width           =   5415
      Begin VB.CommandButton cmdRead 
         Caption         =   "Read Response"
         Height          =   495
         Left            =   3120
         TabIndex        =   7
         ToolTipText     =   "Reads response from a device or from the input biuffer"
         Top             =   360
         Width           =   2055
      End
      Begin VB.CheckBox ckDispAll 
         Caption         =   "Display All Characters"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         ToolTipText     =   "Displays all characters"
         Top             =   720
         Width           =   2415
      End
      Begin VB.CheckBox ckByteCnt 
         Caption         =   "Display Byte Count"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         ToolTipText     =   "Shows number of serial characters received"
         Top             =   480
         Width           =   2295
      End
      Begin VB.CheckBox ckAuto 
         Caption         =   "Auto Query"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         ToolTipText     =   "Enables automatic read if '?' is in the command string"
         Top             =   240
         Value           =   1  'Checked
         Width           =   1455
      End
      Begin VB.TextBox txtResp 
         Height          =   1815
         Left            =   240
         MultiLine       =   -1  'True
         TabIndex        =   3
         Top             =   1080
         Width           =   4935
      End
   End
   Begin VB.Frame frmCmd 
      Caption         =   "Response"
      Height          =   1335
      Left            =   480
      TabIndex        =   0
      Top             =   1680
      Width           =   5415
      Begin VB.ComboBox combCmd 
         Height          =   315
         Left            =   240
         TabIndex        =   22
         ToolTipText     =   "Enter 4895 commands or device commands"
         Top             =   840
         Width           =   4095
      End
      Begin VB.CommandButton cmdSend 
         Caption         =   "Send"
         Height          =   375
         Left            =   4560
         TabIndex        =   1
         ToolTipText     =   "Sends comand to the selected device or to the 4895"
         Top             =   840
         Width           =   615
      End
   End
   Begin VB.Image ImageICS 
      Appearance      =   0  'Flat
      Height          =   765
      Left            =   6120
      Picture         =   "Serial_Terminal.frx":030A
      Stretch         =   -1  'True
      Top             =   6120
      Width           =   2340
   End
   Begin VB.Label lblTitle 
      Caption         =   "ICS Serial Device program for Visual Basic"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1560
      TabIndex        =   21
      Top             =   0
      Width           =   5175
   End
   Begin VB.Label lblLPCtr 
      Caption         =   "Loop Count"
      Height          =   255
      Left            =   4680
      TabIndex        =   16
      Top             =   6240
      Visible         =   0   'False
      Width           =   975
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*********************************************************************************
'   Revised 2-3-2005
'
'   Responds like a serial device.  Receives any command and responds with
'   ok<LF>
'
'   Copyright ICS Electronics 2005
'********************************************************************************
' 2-9-05 Made Settings a global string, removed MSComm1 from frmPorts
'********************************************************************************

'Public gCP             'COM Port selected 0=none
Public DevSet           '1 if user entered adevice address
Public Addr$            'GPIB device address
Dim Instring As String  'reads 4895 responses
Public CmdLPFlg         'enables timer to run command loop
Public LpCtr            'counts number of completed command loops
Public Respcount&           'response msg counter
Public Refmsg$          'Reference received msg
Public RstTime          'Reset flag
Public vbCr

Private Sub cmdExit_Click()
    ' Close the serial port.
    If CP <> 0 Then MSComm1.PortOpen = False
    End
End Sub

Private Sub cmdInit_Click()
    'Dim Instring As String
    txtERROR.Visible = False
    RstTime = 0
    Instring = ""

    cmdRead.Enabled = True
    cmdReset.Enabled = True
    cmdSend.Enabled = True
    cmdStartLP.Enabled = True
    cmdStopLP.Enabled = True
    ckAuto.Enabled = True
    ckByteCnt.Enabled = True
    ckDispAll.Enabled = True
    ckERRStp.Enabled = True
initexit:
End Sub

Private Sub cmdInitCP_Click()
    frmPorts.Show 1
    If gCP <> 0 Then
        cmdInit.Enabled = True
        txtERROR.Visible = False
        ' Notes from MS VB help
        ' Buffer to hold input string
        ' Dim Instring As String
        ' MSComm1.CommPort = n
        ' COM port selected on frmPorts
        ' 9600 baud, no parity, 8 data, and 1 stop bit.
        ' MSComm1.Settings = "9600,N,8,1"
        ' Settings set on frmPorts
        ' Tell the control to read entire buffer when Input
        ' is used.
        MSComm1.InputLen = 0
        ' Open the port.
        MSComm1.CommPort = gCP
        MSComm1.Settings = Settings
        MSComm1.PortOpen = True
        ' end the attention command to the modem.
        ' MSComm1.Output = "ATV1Q0" & Chr$(13) ' Ensure that
        ' the modem responds with "OK".
        ' Wait for data to come back to the serial port.
        'Do
        '    DoEvents
         '   Buffer$ = Buffer$ & MSComm1.Input
        'Loop Until InStr(Buffer$, "OK" & vbCrLf)
        ' Read the "OK" response data in the serial port.
        ' Close the serial port.
        'MSComm1.PortOpen = False
    Else
        txtERROR.Text = "No COM Port Selected"
        Beep
        txtERROR.Visible = True
    End If
        
End Sub

Private Sub cmdRead_Click()
    txtERROR.Visible = False
    RstTime = 0
                              'non formatted read
    Do While MSComm1.InBufferCount <> 0
        Buffer$ = ""
        Doctr& = 0
        Do
            DoEvents
            Buffer$ = Buffer$ & MSComm1.Input
            If Doctr& > 20000 Then
                txtERROR.Text = "Program Timeout - no terminator"     'error exit
                txtERROR.Visible = True
                Beep
                txtResp.Text = "Bad response =" & Buffer$
                CmdLPFlg = 0            'stop any loop
                GoTo readexit:
            End If
            Doctr& = Doctr& + 1
        Loop Until (InStr(Buffer$, vbCr) <> 0) Or (InStr(Buffer$, vbLf) <> 0)
        Call Tdelay(0.1)
    Loop
    L = Len(Buffer$)
    If L <> 0 Then
    'If ckDispAll.Value = 0 And optAutoFmt(0).Value = True Then
        If ckDispAll.Value = 0 Then
            If InStr(Buffer$, vbCr) <> 0 Then
                Buffer$ = Left$(Buffer$, InStr(Buffer$, vbCr) - 1)
            ElseIf InStr(Buffer$, vbLf) <> 0 Then
                Buffer$ = Left$(Buffer$, InStr(Buffer$, vbLf) - 1)
            End If
        End If
        txtResp.Text = Buffer$
    Else
        txtResp.Text = "Nothing in buffer"
    End If
    If ckByteCnt.Value = 1 Then
        txtResp.Text = txtResp.Text & NL & "Count = " & Str$(L)
    End If

readexit:
End Sub


Private Sub cmdSend_Click()
    txtERROR.Visible = False
    RstTime = 0
    MSComm1.Output = combCmd & Chr$(13)
    txtResp.Text = "Message sent=" & combCmd
    
SendExit:
End Sub

Private Sub cmdStartLP_Click()
    txtERROR.Visible = False
    RstTime = 0
    combCmd.Text = ""
    txtResp.Text = ""
    CmdLPFlg = 1
    LpCtr = 0
    Respcount& = 1
    Timer1.Interval = 50
    
End Sub

Private Sub cmdStopLP_Click()
     CmdLPFlg = 0
     lblLPCtr.Visible = False
     txtLpCtr.Visible = False
     Timer1.Interval = 500
End Sub

Private Sub Form_Load()
    gCP = 0
    vbCr = Chr$(13)
    NL = Chr$(13) & Chr$(10)
    RstTime = 0
    txtERROR.Visible = False
    Rev$ = "Revised 02-09-2005"
    txtRev.Text = Rev$
    combCmd.Text = ""
    ckAuto.Value = 0
    ckByteCnt.Value = 0
    ckDispAll.Value = 0
    ckAuto.Enabled = False
    ckByteCnt.Enabled = False
    ckDispAll.Enabled = False
    ckERRStp.Enabled = False
    cmdExit.Enabled = True
    cmdInitCP.Enabled = True
    cmdInit.Enabled = False
    cmdRead.Enabled = False
    cmdReset.Enabled = False
    cmdSend.Enabled = False
    cmdStartLP.Enabled = False
    cmdStopLP.Enabled = False
    frmPorts.Hide
End Sub

Private Sub Timer1_Timer()
    If CmdLPFlg = 1 Then
      lblLPCtr.Visible = True
      txtLpCtr.Visible = True
        
      If MSComm1.InBufferCount <> 0 Then
        Do While MSComm1.InBufferCount <> 0
            Buffer$ = ""
            Doctr& = 0
            Do
                DoEvents
                Buffer$ = Buffer$ & MSComm1.Input
                If Doctr& > 20000 Then
                    txtERROR.Text = "Program Timeout - no terminator"     'error exit
                    txtERROR.Visible = True
                    Beep
                    txtResp.Text = "Bad response =" & Buffer$
                    CmdLPFlg = 0            'stop any loop
                    GoTo Timerexit:
                End If
                Doctr& = Doctr& + 1
            Loop Until (InStr(Buffer$, vbCr) <> 0) Or (InStr(Buffer$, vbLf) <> 0)
            Call Tdelay(0.1)
        Loop
        L = Len(Buffer$)
        If L <> 0 Then
            If ckDispAll.Value = 0 Then
                If InStr(Buffer$, vbCr) <> 0 Then
                    Buffer$ = Left$(Buffer$, InStr(Buffer$, vbCr) - 1)
                ElseIf InStr(Buffer$, vbLf) <> 0 Then
                    Buffer$ = Left$(Buffer$, InStr(Buffer$, vbLf) - 1)
                End If
            End If
            txtResp.Text = "Received = " & Buffer$
            If ckByteCnt.Value = 1 Then             'displays received byte count
                txtResp.Text = txtResp.Text & NL & "Count = " & Str$(L)
            End If
            If Respcount& = 1 Then Refmsg$ = Buffer$
            If Buffer$ = Refmsg$ Then
                'combCmd.Text = "k, Serial Device received=" & Buffer$
                'combCmd.Text = "ok"
                'combCmd.Text = "23.7"
                MSComm1.Output = "23.7" & Chr$(10)
                'Call Tdelay(0.1)
                'MSComm1.Output = combCmd.Text & Str$(Respcount&) & Chr$(10)
                combCmd.Text = "ok, Serial Device received=" & Buffer$
            Else
                'combCmd.Text = "k, Serial Device received=" & Buffer$
                'MSComm1.Output = "not-o"
                MSComm1.Output = "?" & Chr$(10)
                'Call Tdelay(0.1)
                'MSComm1.Output = combCmd.Text & Str$(Respcount&) & Chr$(10)
                If ckERRStp.Value = 1 Then CmdLPFlg = 0       'stop on error
                combCmd.Text = "not-ok, Serial Device received=" & Buffer$
            End If
            'MSComm1.Output = combCmd.Text & Str$(Respcount&) & Chr$(10)   'put response count LF' in Command msg box
            txtResp.Text = txtResp.Text & NL & combCmd.Text & " sent at count " & Str$(Respcount&)
            Respcount& = Respcount& + 1
        Else
            'txtResp.Text = txtResp.Text + NL + "Timeout error - Nothing in buffer"
        End If
      Else
        'txtResp.Text = "Nothing in buffer to read"
      End If
      
      LpCtr = LpCtr + 1
      txtLpCtr.Text = LpCtr
Timerexit: End If
End Sub


Public Sub Tdelay(delaytime)
   starttime = Timer
   Do Until Timer >= starttime + delaytime
   Loop
End Sub

